; 7
;            .
;   F1      , 
;     .    ,   R -
; (  1 -)
;

 
.model small
.stack	100h
.data
;-------------------------------------
color 	db	7	
color1	db	1
flag	db	0
er	db	0
;-------------------------------------
ports	macro	prt,nreg,val ;
	mov	dx,prt
	mov	al,nreg			
	out	dx,al
	
	inc 	dx
	
	mov 	al,val
	out 	dx,al
endm
;--------------------------------------
.code
	mov 	ax,@data
 	mov 	ds,ax

 	mov	ax,0a000h		;  
	mov	es,ax

	mov	AH,0			; 640480		
	MOV	AL,12H			;	
 	INT 	10H			;

main:	call	draw

	mov	ah,00h			;   		
	int	16h			;
    
	cmp	al,1bh		;ESC-Exit
	jne	m0
	cmp	ah,01h
	je	exit
	
m0:	cmp	ah,3bh		;F1-Copy
	jne	m1
	add	flag,1		;    1
	call	fcopy

m1:	cmp	al,45H		;E-ERASE
	jne	m2	
	
	call	erase	
	mov	er,1	        ;   1
		
m2:	cmp	al,52H		;R-Restart
	jne	m3
	mov	flag,0		; 
	mov	er,0		;

m3:	jmp	main	

exit:	mov	ax,4c00h
	int	21h
;------------------- --------------------------------
erase	proc
	mov	bx,0
	xor 	si,si
	mov 	cx,480*80
	

beg1:	ports	3c4h,2,0fh
	ports	3ceh,8,0ffh
	mov	byte ptr es:[bx][si],0

	inc 	si
	cmp 	si,80

	jb	lp
	add 	bx,80
	xor	si,si
lp:	loop 	beg1


	ret
erase 	endp
;---------------------- --------------------------
fcopy	proc
	;-----------------------------------------------------------
	cmp	flag,1			;  
	jne	k1
	mov	bp,0			;
	jmp	kop
	;-----------------------------------------------------------
k1:	cmp	flag,2			;  
	jne	k2		
	mov	bp,420*80		;
	jmp	kop
	;-----------------------------------------------------------
k2:	cmp	flag,3			;  	
	je	kop1
	ret
kop1:	mov	bp,420*80+64		;
	;-----------------------------------------------------------


kop:	ports 	3ceh,5,1		;   (1 )
	mov	bx,64			;    
	mov	cx,60*16		;16    60 

beg3:	mov	al,es:[bx][si]				
	mov	es:[bp][si],al
	
	inc	si
	cmp	si,16

	jb	lp3
	xor	si,si
	add	bx,80
	add	bp,80
lp3:	loop	beg3

	ports	3ceh,5,2		;   (2 )
					;    draw
	ret
fcopy	endp

;--------------------------------------------------------------
draw 	Proc
	cmp	er,1			;    E - ,  
					; ,    
	jne	mt1	
	ret

mt1:	cmp	flag,0			;     F1,  
					;     
	je	mt2
	ret
		
mt2:	mov	bx,64
	xor 	si,si
	mov 	cx,60*16

	ports	3c4h,2,0fh
	ports	3ceh,8,0ffh
	mov	byte ptr es:[bx][si],0

begin:	
	;--------  ------------
	cmp	si,8				;     
						;
	jne	met1

	ports 	3c4h,2,color1
	mov 	byte ptr es:[bx][si],0ffh
	inc	si
	jmp	lp1		

	;--------  ---------- 
met1:	
	cmp	bx,64+80*25			;     
						;
	jne	met2	
	
	push	cx
	mov	cx,8*16
	
beg:	ports 	3c4h,2,color1
	mov 	byte ptr es:[bx][si],0ffh
	inc	si
	cmp 	si,16

	jb	lp2
	add 	bx,80
	xor	si,si
lp2:	loop beg
	pop	cx
	sub	cx,8*16	


met2:	;--------- ----------------------------
	ports 	3c4h,2,color
	mov 	byte ptr es:[bx][si],0ffh

	inc 	si
	cmp 	si,16

	jb	lp1
	add 	bx,80
	xor	si,si
lp1:	loop begin

	ret

draw endp
;----------------------------------------------------

end
	